'use strict';

var typeId = 0;
function ActionReducer(initState, prefix) {
    var _reducers = {};
    var createAction = function (type, reducer) {
        if (typeof type === 'function') {
            reducer = type;
            type = "@@ActionReducer-" + ++typeId;
        }
        type = prefix ? prefix + "/" + type : type;
        var actionCreator = (function (payload) { return ({ type: type, payload: payload }); });
        actionCreator.type = type;
        _reducers[type] = reducer;
        return actionCreator;
    };
    var reducer = function (state, action) {
        if (state === void 0) { state = initState; }
        var reducer = _reducers[action.type];
        return reducer ? reducer(state, action.payload) : state;
    };
    return { createAction: createAction, reducer: reducer };
}

module.exports = ActionReducer;
