export interface Action<P> {
    type: string | symbol;
    payload: P;
}
export interface PayloadActionCreator<P> {
    (payload: P): Action<P>;
    type: string | symbol;
}
export interface EnptyActionCreator {
    (payload?: undefined): Action<undefined>;
    type: string | symbol;
}
export interface OptionalActionCreator<P> {
    (payload?: P): Action<P | undefined>;
    type: string | symbol;
}
export default function ActionReducer<S>(initState: S, prefix?: string): {
    createAction: {
        (reducer: (state: S, payload: undefined) => S): EnptyActionCreator;
        (type: string | symbol, reducer: (state: S, payload: undefined) => S): EnptyActionCreator;
        <P>(reducer: (state: S, payload: P) => S): PayloadActionCreator<P>;
        <P>(type: string | symbol, reducer: (state: S, payload: P) => S): PayloadActionCreator<P>;
    };
    reducer: (state: S | undefined, action: {
        type: any;
    }) => S;
};
