let typeId = 0;
export default function ActionReducer(initState, prefix) {
    const _reducers = {};
    const createAction = (type, reducer) => {
        if (typeof type === 'function') {
            reducer = type;
            type = `@@ActionReducer-${++typeId}`;
        }
        type = prefix ? `${prefix}/${type}` : type;
        const actionCreator = ((payload) => ({ type, payload }));
        actionCreator.type = type;
        _reducers[type] = reducer;
        return actionCreator;
    };
    const reducer = (state = initState, action) => {
        const reducer = _reducers[action.type];
        return reducer ? reducer(state, action.payload) : state;
    };
    if (process.env.NODE_ENV !== 'production') {
        const resultType = { createAction, reducer };
        return { createAction, reducer, _reducers };
    }
    return { createAction, reducer };
}
